<?php
/*
Simple:Press Plugin Title: Topic Description
Version: 1.2.7
Plugin URI: http://simple-press.com
Description: A Simple:Press plugin for allowing users to add an optional topic description when creating new topics
Author: Andy Staines & Steve Klasen
Author URI: http://simple-press.com
Simple:Press Versions: 5.2 and above
$LastChangedDate: 2015-01-02 09:51:41 -0800 (Fri, 02 Jan 2015) $
$Rev: 12294 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# IMPORTANT DB VERSION
define('SPTDDBVERSION', 0);

define('SPTDDIR', 		SFPLUGINDIR.'topic-description/');
define('SPTDADMINDIR', 	SFPLUGINDIR.'topic-description/admin/');
define('SPTDAHAHDIR', 	SFPLUGINDIR.'topic-description/ahah/');
define('SPTDLIBDIR', 	SFPLUGINDIR.'topic-description/library/');
define('SPTDLIBURL', 	SFPLUGINURL.'topic-description/library/');
define('SPTDCSS', 		SFPLUGINURL.'topic-description/resources/css/');
define('SPTDSCRIPT', 	SFPLUGINURL.'topic-description/resources/jscript/');
define('SPTDIMAGES', 	SFPLUGINURL.'topic-description/resources/images/');
define('SPTDTAGSDIR', 	SFPLUGINDIR.'topic-description/template-tags/');

add_action('init', 												                   'sp_topic_description_localization');
add_action('sph_activate_topic-description/sp-topic-description-plugin.php', 	   'sp_topic_description_install');
add_action('sph_uninstall_topic-description/sp-topic-description-plugin.php',      'sp_topic_description_uninstall');
add_action('sph_deactivate_topic-description/sp-topic-description-plugin.php',     'sp_topic_description_deactivate');
add_action('sph_activated', 				                                       'sp_topic_description_sp_activate');
add_action('sph_deactivated', 				                                       'sp_topic_description_sp_deactivate');
add_action('sph_uninstalled', 								                       'sp_topic_description_sp_uninstall');
add_action('sph_plugin_update_topic-description/sp-topic-description-plugin.php',  'sp_topic_description_upgrade_check');
add_action('admin_footer',                                                         'sp_topic_description_upgrade_check');
add_action('sph_print_plugin_styles',							                   'sp_topic_description_head');
add_action('sph_post_create',                                                      'sp_topic_description_create_topic');
add_action('sph_topic_title_edited',                                               'sp_topic_description_edit_topic_desc');

add_filter('sph_plugins_active_buttons',    'sp_topic_description_uninstall_option', 10, 2);
add_filter('sph_topic_editor_name',         'sp_topic_description_topic_form', 10, 2);
add_filter('sph_TopicHeaderName',           'sp_topic_description_display_desc', 10, 2);
add_filter('sph_topicview_query', 			'sp_topic_description_query');
add_filter('sph_topicview_topic_record', 	'sp_topic_description_records', 10, 2);
add_filter('sph_forumview_query', 			'sp_topic_description_query');
add_filter('sph_forumview_topic_records', 	'sp_topic_description_records', 10, 2);
add_filter('sph_topic_title_edit',          'sp_topic_description_edit', 10, 2);

function sp_topic_description_localization() {
	sp_plugin_localisation('sp-topic-description');
}

function sp_topic_description_install() {
    include_once(SPTDDIR.'sp-topic-description-install.php');
    sp_topic_description_do_install();
}

function sp_topic_description_uninstall() {
    include_once(SPTDDIR.'sp-topic-description-uninstall.php');
    sp_topic_description_do_uninstall();
}

function sp_topic_description_deactivate() {
    include_once(SPTDDIR.'sp-topic-description-uninstall.php');
    sp_topic_description_do_deactivate();
}

function sp_topic_description_sp_activate() {
	include_once(SPTDDIR.'sp-topic-description-install.php');
    sp_topic_description_do_sp_activate();
}

function sp_topic_description_sp_deactivate() {
	include_once(SPTDDIR.'sp-topic-description-uninstall.php');
    sp_topic_description_do_sp_deactivate();
}

function sp_topic_description_sp_uninstall() {
	include_once(SPTDDIR.'sp-topic-description-uninstall.php');
    sp_topic_description_do_sp_uninstall();
}

function sp_topic_description_uninstall_option($actionlink, $plugin) {
    include_once(SPTDDIR.'sp-topic-description-uninstall.php');
    $actionlink = sp_topic_description_uninstall_option_links($actionlink, $plugin);
	return $actionlink;
}

function sp_topic_description_upgrade_check() {
    include_once(SPTDDIR.'sp-topic-description-upgrade.php');
    sp_topic_description_do_upgrade_check();
}

function sp_topic_description_head() {
    include_once(SPTDLIBDIR.'sp-topic-description-components.php');
    sp_topic_description_do_head();
}

function sp_topic_description_topic_form($out, $a) {
    include_once(SPTDLIBDIR.'sp-topic-description-components.php');
    $out = sp_topic_description_do_topic_form($out, $a);
	return $out;
}

function sp_topic_description_create_topic($newpost) {
    include_once(SPTDLIBDIR.'sp-topic-description-components.php');
    sp_topic_description_do_create_topic($newpost);
}

function sp_topic_description_query($query) {
	$query->fields.= ', topic_desc';
	return $query;
}

function sp_topic_description_records($data, $record) {
	$data->topic_desc = $record->topic_desc;
	return $data;
}

function sp_topic_description_display_desc($out, $a) {
    include_once(SPTDLIBDIR.'sp-topic-description-components.php');
    $out = sp_topic_description_do_display_desc($out, $a);
	return $out;
}

function sp_topic_description_edit($out, $topic){
    include_once(SPTDLIBDIR.'sp-topic-description-components.php');
    $out = sp_topic_description_do_edit($out, $topic);
	return $out;
}

function sp_topic_description_edit_topic_desc($topicid) {
    include_once(SPTDLIBDIR.'sp-topic-description-components.php');
    sp_topic_description_do_edit_topic_desc($topicid);
}

# Define Template Tags globally available (dont have to be enabled on template tag panel)

function sp_TopicDescription($args='') {
    include_once(SPTDTAGSDIR.'sp-topic-description-tag.php');
	sp_do_TopicDescription($args);
}

?>